package net.anzix.osm.upload.data;

import android.database.sqlite.SQLiteDatabase;

import java.util.Map;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.AbstractDaoSession;
import de.greenrobot.dao.identityscope.IdentityScopeType;
import de.greenrobot.dao.internal.DaoConfig;

import net.anzix.osm.upload.data.Source;
import net.anzix.osm.upload.data.Gpx;

import net.anzix.osm.upload.data.SourceDao;
import net.anzix.osm.upload.data.GpxDao;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.

/**
 * {@inheritDoc}
 * 
 * @see de.greenrobot.dao.AbstractDaoSession
 */
public class DaoSession extends AbstractDaoSession {

    private final DaoConfig sourceDaoConfig;
    private final DaoConfig gpxDaoConfig;

    private final SourceDao sourceDao;
    private final GpxDao gpxDao;

    public DaoSession(SQLiteDatabase db, IdentityScopeType type, Map<Class<? extends AbstractDao<?, ?>>, DaoConfig>
            daoConfigMap) {
        super(db);

        sourceDaoConfig = daoConfigMap.get(SourceDao.class).clone();
        sourceDaoConfig.initIdentityScope(type);

        gpxDaoConfig = daoConfigMap.get(GpxDao.class).clone();
        gpxDaoConfig.initIdentityScope(type);

        sourceDao = new SourceDao(sourceDaoConfig, this);
        gpxDao = new GpxDao(gpxDaoConfig, this);

        registerDao(Source.class, sourceDao);
        registerDao(Gpx.class, gpxDao);
    }
    
    public void clear() {
        sourceDaoConfig.getIdentityScope().clear();
        gpxDaoConfig.getIdentityScope().clear();
    }

    public SourceDao getSourceDao() {
        return sourceDao;
    }

    public GpxDao getGpxDao() {
        return gpxDao;
    }

}
